require "mathlib"
require "rng"
require "definedLines"
local shine = require("shine")

io.stdout:setvbuf("no")


ScrW = 1260
ScrH = 785

love.window.setMode(ScrW,ScrH, {vsync=false})

local blur1 = shine.boxblur()
blur1.radius_v = 4
postEffect1 = blur1
local blur5 = shine.boxblur()
blur5.radius_v = 64
postEffect5 = blur5
local blur4 = shine.boxblur()
blur4.radius_v = 32
postEffect4 = blur4
local blur3 = shine.boxblur()
blur3.radius_v = 16
postEffect3 = blur3
local blur2 = shine.boxblur()
blur2.radius_v = 8
postEffect2 = blur2

local CREDITS = 100
local BET = 5
local WIN = 0



items = {}
items[1] = {love.graphics.newImage("icons/bar2.png"),1}
items[2] = {love.graphics.newImage("icons/red2.png"),1}
items[3] = {love.graphics.newImage("icons/yellow2.png"),1}
items[4] = {love.graphics.newImage("icons/blue2.png"),1}
items[5] = {love.graphics.newImage("icons/orange2.png"),1}
items[6] = {love.graphics.newImage("icons/wine2.png"),4}
items[7] = {love.graphics.newImage("icons/melon2.png"),6}
items[8] = {love.graphics.newImage("icons/72.png"),16}
items[9] = {love.graphics.newImage("icons/multiplay.png"),1}

local winImage = love.graphics.newImage("icons/Atlas13.png")
local winFrame = {}
winFrame[1] = love.graphics.newImage("icons/winFrame1.png")
winFrame[2] = love.graphics.newImage("icons/winFrame4.png")

local multFrame = {}
multFrame[1] = {}
multFrame[1][1] = love.graphics.newImage("icons/mult_x2_1.png")
multFrame[1][2] = love.graphics.newImage("icons/mult_x2_2.png")
multFrame[1][3] = love.graphics.newImage("icons/mult_x2_3.png")
multFrame[1][4] = love.graphics.newImage("icons/mult_x2_4.png")
multFrame[1][5] = love.graphics.newImage("icons/mult_x2_5.png")
multFrame[2] = {}
multFrame[2][1] = love.graphics.newImage("icons/mult_x4_1.png")
multFrame[2][2] = love.graphics.newImage("icons/mult_x4_2.png")
multFrame[2][3] = love.graphics.newImage("icons/mult_x4_3.png")
multFrame[2][4] = love.graphics.newImage("icons/mult_x4_4.png")
multFrame[2][5] = love.graphics.newImage("icons/mult_x4_5.png")
multFrame[3] = {}
multFrame[3][1] = love.graphics.newImage("icons/mult_x8_1.png")
multFrame[3][2] = love.graphics.newImage("icons/mult_x8_2.png")
multFrame[3][3] = love.graphics.newImage("icons/mult_x8_3.png")
multFrame[3][4] = love.graphics.newImage("icons/mult_x8_4.png")
multFrame[3][5] = love.graphics.newImage("icons/mult_x8_5.png")



GFXoverlay = love.graphics.newImage("icons/overlay.png")
LogoAnim = love.graphics.newImage("icons/anim_logo.png")

function newAnimation(image, width, height, duration)
    local animation = {}
    animation.spriteSheet = image;
    animation.quads = {};
 
    for y = 0, image:getHeight() - height, height do
        for x = 0, image:getWidth() - width, width do
            table.insert(animation.quads, love.graphics.newQuad(x, y, width, height, image:getDimensions()))
        end
    end
 
    animation.duration = duration or 1
    animation.currentTime = 0
 
    return animation
end

local curTime = 0

local sounds = {}
sounds[1] = love.audio.newSource("sfx/spin.ogg","static")
sounds[1]:setVolume(0.4)
sounds[2] = love.audio.newSource("sfx/highlight.ogg","static")
sounds[3] = love.audio.newSource("sfx/win_x2.ogg","static")
sounds[4] = love.audio.newSource("sfx/total_win.ogg","static")
sounds[5] = love.audio.newSource("sfx/win_x4.ogg","static")
sounds[6] = love.audio.newSource("sfx/win_x8.ogg","static")
sounds[7] = love.audio.newSource("sfx/win00001.ogg","static")
sounds[8] = love.audio.newSource("sfx/win00002.ogg","static")
sounds[9] = love.audio.newSource("sfx/winExtra.ogg","static")
sounds[10] = love.audio.newSource("sfx/bet.ogg","static")
sounds[11] = love.audio.newSource("sfx/reelStop.ogg","static")
sounds[11]:setVolume(0.4)
sounds[12] = love.audio.newSource("sfx/win00016.ogg","static")
sounds[13] = love.audio.newSource("sfx/win00060.ogg","static")
sounds[14] = love.audio.newSource("sfx/win00160.ogg","static")
sounds[15] = love.audio.newSource("sfx/win00006.ogg","static")
sounds[16] = love.audio.newSource("sfx/draft.ogg","static")
sounds[17] = love.audio.newSource("sfx/multi.ogg","static")
sounds[17]:setVolume(0.4)
sounds[16]:setVolume(0.4)
sounds[18] = love.audio.newSource("sfx/transform.ogg","static")
sounds[18]:setVolume(0.6)





local GameSizeX = 210
local GameSizeY = 169
local GameSpeed = 1.85
local GameSpeedBase = 6
local yOffset = -38
local xOffset = 138 

local winRate = 1
local winRateDynamic = winRate
local multiRate = 50

local funMode = 0
local funModeSpin = 0
local funModeWinItem = 0
local funModeWinChance = 1 --1 = always win
local funModeSpecialWinChance = 2 --Melon, wine Seven

if funMode == 1 then
	multiRate = 200
end

Slider = {}
Slider[1] = {}
Slider[1].x = xOffset
Slider[1].y = yOffset
Slider[1].spinTime = 600
Slider[1].lastID = 0
Slider[1].stop = 0
Slider[1].multiplaySymbol = 0
Slider[1].speed = GameSpeed

Slider[2] = {}
Slider[2].x = xOffset+GameSizeX+48
Slider[2].y = yOffset
Slider[2].spinTime = 800
Slider[2].lastID = 0
Slider[2].stop = 0
Slider[2].multiplaySymbol = 0
Slider[2].speed = GameSpeed

Slider[3] = {}
Slider[3].x = xOffset+(GameSizeX+48)*2
Slider[3].y = yOffset
Slider[3].spinTime = 900
Slider[3].lastID = 0
Slider[3].stop = 0
Slider[3].multiplaySymbol = 0
Slider[3].speed = GameSpeed

Slider[4] = {}
Slider[4].x = xOffset+(GameSizeX+48)*3
Slider[4].y = yOffset
Slider[4].spinTime = 1000
Slider[4].lastID = 0
Slider[4].stop = 0
Slider[4].multiplaySymbol = 0
Slider[4].speed = GameSpeed

local IteamDrawIDs = {}

local spinTimer = 0
local transformTimer = 1

local SPIN = 0
local STOP = 0
local WIN = 0
local winChanceModifier_base = 0
local winChanceModifier = 0
local bonusWinChance = 0
local multiplayMod_base = 0
local multiplayMod = 0

love.window.setTitle("Multiplay81 - realistic")

function setWinRate(chanceMod, bonusMod, multiMod)
	winChanceModifier_base = chanceMod
	winChanceModifier = winChanceModifier_base
	bonusWinChance = bonusMod
	multiplayMod_base = multiMod
	multiplayMod = multiplayMod_base+1
end



winLines = {}
local payLines = {}

LINES = {}

local SEED = os.time()
local SEED2 = 055+os.time()
local RNG = lcg(SEED)
local RNG2 = mwc(SEED)
local RNG3 = twister(SEED)
local RNG4 = lcg(SEED)
local RNG5 = lcg(SEED)

local itemCount_1 = 0
local itemCount_2 = 0
local itemCount_3 = 0
local itemCount_4 = 0
local itemCount_5 = 0
local itemCount_6 = 0
local itemCount_7 = 0
local itemCount_8 = 0

Slider[1].itemCount = {}
Slider[1].itemCount[1] = 0
Slider[1].itemCount[2] = 0
Slider[1].itemCount[3] = 0
Slider[1].itemCount[4] = 0
Slider[1].itemCount[5] = 0
Slider[1].itemCount[6] = 0
Slider[1].itemCount[7] = 0
Slider[1].itemCount[8] = 0

Slider[2].itemCount = {}
Slider[2].itemCount[1] = 0
Slider[2].itemCount[2] = 0
Slider[2].itemCount[3] = 0
Slider[2].itemCount[4] = 0
Slider[2].itemCount[5] = 0
Slider[2].itemCount[6] = 0
Slider[2].itemCount[7] = 0
Slider[2].itemCount[8] = 0

Slider[3].itemCount = {}
Slider[3].itemCount[1] = 0
Slider[3].itemCount[2] = 0
Slider[3].itemCount[3] = 0
Slider[3].itemCount[4] = 0
Slider[3].itemCount[5] = 0
Slider[3].itemCount[6] = 0
Slider[3].itemCount[7] = 0
Slider[3].itemCount[8] = 0

Slider[4].itemCount = {}
Slider[4].itemCount[1] = 0
Slider[4].itemCount[2] = 0
Slider[4].itemCount[3] = 0
Slider[4].itemCount[4] = 0
Slider[4].itemCount[5] = 0
Slider[4].itemCount[6] = 0
Slider[4].itemCount[7] = 0
Slider[4].itemCount[8] = 0

function linesInsertSlider(sliderId)
	local itemList = {}

	for i=1,5 do
		if Slider[sliderId][i].y < 150 and Slider[sliderId][i].y > 150-GameSizeY then
			itemList[1] = i
		elseif Slider[sliderId][i].y < 150+GameSizeY and Slider[sliderId][i].y > (150+GameSizeY)-GameSizeY then
			itemList[2] = i
		elseif Slider[sliderId][i].y < 150+GameSizeY*2 and Slider[sliderId][i].y > (150+GameSizeY*2)-GameSizeY  then
			itemList[3] = i
		end
	end

	if Slider[sliderId][itemList[1]].item[1] == items[9][1] then
		Slider[sliderId].multiplaySymbol = 1
	end
	if Slider[sliderId][itemList[2]].item[1] == items[9][1] then
		Slider[sliderId].multiplaySymbol = 1
	end
	if Slider[sliderId][itemList[3]].item[1] == items[9][1] then
		Slider[sliderId].multiplaySymbol = 1
	end

	LINES[sliderId] = itemList
	if Slider[sliderId].multiplaySymbol == 1 then
		love.audio.stop(sounds[17])
		love.audio.play(sounds[17])
	end

end

function checkPay()

	for k,v in ipairs(winLines) do
		local wildCount = 0
		local winValue = 1
		local multiplier = 1
		local winValItem = items[1]
		for o,p in ipairs(v) do
			if p.item[1] == items[9][1] then
				wildCount = wildCount + 1
				--winValue = 1
			else
				if #v > 3 then
					local fullLineMul = 1
					if p.item[1] == items[1][1] then
						fullLineMul = 2
					elseif p.item[1] == items[2][1] or p.item[1] == items[3][1] or p.item[1] == items[4][1] or p.item[1] == items[5][1] then
					    fullLineMul = 4
					else
						fullLineMul = 10
					end
					winValue = p.item[2]*fullLineMul
					winValItem = p.item[1]
				else
					winValue = p.item[2]
					winValItem = p.item[1]
				end
			end
		end
		if wildCount < 3 then
			if wildCount == 0 then
				multiplier = 1
			else
				multiplier = wildCount * 2
			end
		else
			multiplier = 8
		end
		payLines[k] = {winValue, multiplier, winValItem}
	end
end

local melonChanceMod = 1000

local winSevens = RNG:random(1,10000)
local winSevensChance = 10
local winSevensSPIN = 0

function getRandom(SliderNum)
	local item
	local R
	local R3
	local finalResult

	if SliderNum == 2 or SliderNum == 4 then
		R = RNG2:random(0,1000)
		R3 = RNG3:random(1,9)
	else
		R = RNG2:random(0,1000)
		R3 = RNG3:random(1,9)
	end

	if melonChanceMod < 1000 then
		if RNG:random(1,15) < 5-(Slider[1].itemCount[7] + Slider[2].itemCount[7] + Slider[3].itemCount[7]) then
			R3 = 7
			melonChanceMod = Slider[1].itemCount[7] + Slider[2].itemCount[7] + Slider[3].itemCount[7]*100
		end
	end

	if Slider[1].multiplaySymbol == 1 then
		if SliderNum == 2 then
			multiplayMod = 0
		else
			multiplayMod = multiplayMod - multiplayMod/(1000-winChanceModifier)
		end
	end
	if Slider[2].multiplaySymbol == 1 then
		multiplayMod = multiplayMod - multiplayMod/(1000-winChanceModifier)
	end
	if Slider[3].multiplaySymbol == 1 then
		multiplayMod = multiplayMod - multiplayMod/(1000-winChanceModifier)
	end
	if Slider[1].multiplaySymbol == 1 and Slider[2].multiplaySymbol == 1 and Slider[3].multiplaySymbol == 1 then
		multiplayMod = 0
	end

	if spinTimer < Slider[SliderNum].spinTime-GameSpeed*20 then
		multiplayMod = 800
	else
		multiplayMod = multiplayMod_base
	end

	if Slider[1].itemCount[1] + Slider[2].itemCount[1] < 3 and
		Slider[1].itemCount[2] + Slider[2].itemCount[2] < 3 and
		Slider[1].itemCount[3] + Slider[2].itemCount[3] < 3 and
		Slider[1].itemCount[4] + Slider[2].itemCount[4] < 3 and
		Slider[1].itemCount[5] + Slider[2].itemCount[5] < 2 and
		Slider[1].itemCount[6] + Slider[2].itemCount[6] < 2 and
		Slider[1].itemCount[7] + Slider[2].itemCount[7] < 2 then
			if SliderNum == 3 or SliderNum == 4 then
				multiplayMod = 350
			end			
	else
		multiplayMod = multiplayMod_base
	end
		




	if R3 == 9 then
		if SliderNum > 2 then
			if R < multiplayMod*1.5 then
				finalResult = 9
			else
				finalResult = RNG:random(1,8)
			end
		else
			if R < multiplayMod then
				finalResult = 9
			else
				finalResult = RNG:random(1,8)
			end
		end
	elseif R3 == 8 then
		if R < 500 then
			finalResult = 8
		else
			finalResult = RNG:random(2,7)
		end
	elseif R3 == 7 then
		if R < 250*(1001-melonChanceMod)  then
			finalResult = 7
		else
			finalResult = RNG:random(2,6)
		end
	elseif R3 == 6 then
		if R < 300  then
			finalResult = 6
		else
			finalResult = RNG:random(1,5)
		end
	else
		finalResult = RNG:random(1,5)
	end

	if finalResult ~= 9 then
	
		if SliderNum == 2 then
			if Slider[1].itemCount[1] > 0 then
				if R < math.clamp(1000-Slider[1].itemCount[1]*(950/winChanceModifier),0,1000) then
					
				else
					while finalResult == 1 do
						finalResult = RNG4:random(1,8)
					end
				end
			end
			if Slider[1].itemCount[2] > 0 then
				if R < math.clamp(1000-Slider[1].itemCount[2]*(950/winChanceModifier),0,1000) then

				else
					while finalResult == 2 do
						finalResult = RNG4:random(1,7)
					end
				end
			end
			if Slider[1].itemCount[3] > 0 then
				if R < math.clamp(1000-Slider[1].itemCount[3]*(950/winChanceModifier),0,1000) then

				else
					while finalResult == 3 do
						finalResult = RNG4:random(1,8)
					end
				end
			end
			if Slider[1].itemCount[4] > 0 then
				if R < math.clamp(1000-Slider[1].itemCount[4]*(950/winChanceModifier),0,1000) then

				else
					while finalResult == 4 do
						finalResult = RNG4:random(1,7)
					end
				end
			end
			if Slider[1].itemCount[5] > 0 then
				if R < math.clamp(1000-Slider[1].itemCount[5]*(950/winChanceModifier),0,1000) then

				else
					while finalResult == 5 do
						finalResult = RNG4:random(1,8)
					end
				end
			end
			if Slider[1].itemCount[6] > 0 then
				if R < math.clamp(1000-Slider[1].itemCount[6]*(1000/winChanceModifier),0,1000) then

				else
					while finalResult == 6 do
						finalResult = RNG4:random(1,7)
					end
				end
			end
			if Slider[1].itemCount[7] > 0 then
				if R < math.clamp(1000-Slider[1].itemCount[7]*(melonChanceMod/winChanceModifier),0,1000) then

				else
					while finalResult == 7 do
						finalResult = RNG4:random(1,7)
					end
				end
			end
		end

		if SliderNum == 3 then
			if Slider[1].itemCount[1] > 0 then
				if Slider[1].itemCount[1] + Slider[2].itemCount[1] > 1 then
					if R < math.clamp(1000-(Slider[1].itemCount[1] + Slider[2].itemCount[1])*(994/winChanceModifier),0,1000) then

					else
						while finalResult == 1 do
							finalResult = RNG4:random(1,8)
						end
					end
				end
			end
			if Slider[1].itemCount[2] > 0 then
			if Slider[1].itemCount[2] + Slider[2].itemCount[2] > 1 then
				if R < math.clamp(1000-(Slider[1].itemCount[2] + Slider[2].itemCount[2])*(994/winChanceModifier),0,200) then

				else
					while finalResult == 2 do
						finalResult = RNG4:random(1,8)
					end
				end
			end
			end
			if Slider[1].itemCount[3] > 0 then
			if Slider[1].itemCount[3] + Slider[2].itemCount[3] > 1 then
				if R < math.clamp(1000-(Slider[1].itemCount[3] + Slider[2].itemCount[3])*(994/winChanceModifier),0,1000) then

				else
					while finalResult == 3 do
						finalResult = RNG4:random(1,8)
					end
				end
			end
			end
			if Slider[1].itemCount[4] > 0 then
			if Slider[1].itemCount[4] + Slider[2].itemCount[4] > 1 then
				if R < math.clamp(1000-(Slider[1].itemCount[4] + Slider[2].itemCount[4])*(994/winChanceModifier),0,1000) then

				else
					while finalResult == 4 do
						finalResult = RNG4:random(1,8)
					end
				end
			end
			end
			if Slider[1].itemCount[5] > 0 then
			if Slider[1].itemCount[5] + Slider[2].itemCount[5] > 1 then
				if R < math.clamp(1000-(Slider[1].itemCount[5] + Slider[2].itemCount[5])*(994/winChanceModifier),0,1000) then

				else
					while finalResult == 5 do
						finalResult = RNG4:random(1,8)
					end
				end
			end
			end
			if Slider[1].itemCount[6] > 0 then
			if Slider[1].itemCount[6] + Slider[2].itemCount[6] > 1 then
				if R < math.clamp(1000-(Slider[1].itemCount[6] + Slider[2].itemCount[6])*(1000/winChanceModifier),0,1000) then

				else
					while finalResult == 6 do
						finalResult = RNG4:random(1,8)
					end
				end
			end
			end
			if Slider[1].itemCount[7] > 0 then
			if Slider[1].itemCount[7] + Slider[2].itemCount[7] > 1 then
				if R < math.clamp(1000-(Slider[1].itemCount[7] + Slider[2].itemCount[7])*(melonChanceMod/winChanceModifier),0,1000) then

				else
					while finalResult == 7 do
						finalResult = RNG4:random(1,8)
					end
				end
			end
			end
			if Slider[1].itemCount[8] > 0 then
			if Slider[1].itemCount[8] + Slider[2].itemCount[8] > 1 then
				if R < math.clamp(1000-(Slider[1].itemCount[8] + Slider[2].itemCount[8])*(melonChanceMod/winChanceModifier),0,1000) then

				else
					while finalResult == 8 do
						finalResult = RNG4:random(1,8)
					end
				end
			end
			end
		end

		if SliderNum == 4 then
			if Slider[1].itemCount[1] > 0 then
			if Slider[1].itemCount[1] + Slider[2].itemCount[1] + Slider[3].itemCount[1] > 1 then
				if R < math.clamp(1000-(Slider[1].itemCount[1] + Slider[2].itemCount[1] + Slider[3].itemCount[1])*(998/math.clamp(winChanceModifier/50,1,1000)),0,1000) then
				else
					while finalResult == 1 do
						finalResult = RNG4:random(1,8)
					end
				end
			end
			end
			if Slider[1].itemCount[2] > 0 then
			if Slider[1].itemCount[2] + Slider[2].itemCount[2] + Slider[3].itemCount[2] > 1 then
				if R < math.clamp(1000-(Slider[1].itemCount[2] + Slider[2].itemCount[2] + Slider[3].itemCount[2])*(998/math.clamp(winChanceModifier/50,1,1000)),0,200) then

				else
					while finalResult == 2 do
						finalResult = RNG4:random(1,8)
					end
				end
			end
			end
			if Slider[1].itemCount[3] > 0 then
			if Slider[1].itemCount[3] + Slider[2].itemCount[3] + Slider[3].itemCount[3] > 1 then
				if R < math.clamp(1000-(Slider[1].itemCount[3] + Slider[2].itemCount[3] + Slider[3].itemCount[3])*(998/math.clamp(winChanceModifier/50,1,1000)),0,1000) then

				else
					while finalResult == 3 do
						finalResult = RNG4:random(1,8)
					end
				end
			end
			end
			if Slider[1].itemCount[4] > 0 then
			if Slider[1].itemCount[4] + Slider[2].itemCount[4] + Slider[3].itemCount[4] > 1 then
				if R < math.clamp(1000-(Slider[1].itemCount[4] + Slider[2].itemCount[4] + Slider[3].itemCount[4])*(998/math.clamp(winChanceModifier/50,1,1000)),0,1000) then

				else
					while finalResult == 4 do
						finalResult = RNG4:random(1,8)
					end
				end
			end
			end
			if Slider[1].itemCount[5] > 0 then
			if Slider[1].itemCount[5] + Slider[2].itemCount[5] + Slider[3].itemCount[5] > 1 then
				if R < math.clamp(1000-(Slider[1].itemCount[5] + Slider[2].itemCount[5] + Slider[3].itemCount[5])*(998/math.clamp(winChanceModifier/50,1,1000)),0,1000) then

				else
					while finalResult == 5 do
						finalResult = RNG4:random(1,8)
					end
				end
			end
			end
			if Slider[1].itemCount[6] > 0 then
			if Slider[1].itemCount[6] + Slider[2].itemCount[6] + Slider[3].itemCount[6] > 1 then
				if R < math.clamp(1000-(Slider[1].itemCount[6] + Slider[2].itemCount[6] + Slider[3].itemCount[6])*(1000/math.clamp(winChanceModifier/80,1,1000)),0,1000) then

				else
					while finalResult == 6 do
						finalResult = RNG4:random(1,8)
					end
				end
			end
			end
			if Slider[1].itemCount[7] > 0 then
			if Slider[1].itemCount[7] + Slider[2].itemCount[7] + Slider[3].itemCount[7] > 1 then
				if R < math.clamp(1000-(Slider[1].itemCount[7] + Slider[2].itemCount[7] + Slider[3].itemCount[7])*(melonChanceMod/math.clamp(winChanceModifier/100,1,1000)),0,1000) then

				else
					while finalResult == 7 do
						finalResult = RNG4:random(1,8)
					end
				end
			end
			end
			if Slider[1].itemCount[8] > 0 then
			if Slider[1].itemCount[8] + Slider[2].itemCount[8] + Slider[3].itemCount[8] > 1 then
				if R < math.clamp(1000-(Slider[1].itemCount[8] + Slider[2].itemCount[8] + Slider[3].itemCount[8])*(melonChanceMod/math.clamp(winChanceModifier/100,1,1000)),0,1000) then

				else
					while finalResult == 8 do
						finalResult = RNG4:random(1,8)
					end
				end
			end
			end
		end

		if funModeSpin == 1 and funMode == 1 then
			local rO = RNG4:random(1,5)
			if funModeWinItem > 5 then
				if spinTimer > 580+rO and spinTimer <= 650-rO and SliderNum == 1 then
					if RNG4:random(1,1+Slider[1].itemCount[funModeWinItem]) < 2 then
						finalResult = funModeWinItem
						item = items[finalResult]
					else
						item = items[finalResult]
					end
					if RNG4:random(1,15) < 2 then
						finalResult = 9
						item = items[finalResult]
					end
				elseif spinTimer > 720+rO and spinTimer <= 790-rO and SliderNum == 2 then
					if RNG4:random(1,1+(Slider[1].itemCount[funModeWinItem])) < 2 then
						finalResult = funModeWinItem
						item = items[finalResult]
					else
						item = items[finalResult]
					end
					if RNG4:random(1,18) < 2 and Slider[1].multiplaySymbol == 0 then
						finalResult = 9
						item = items[finalResult]
					end
				elseif spinTimer > 850+rO and spinTimer <= 950-rO and SliderNum == 3 then
					if RNG4:random(1,1+(Slider[1].itemCount[funModeWinItem]+Slider[2].itemCount[funModeWinItem])*2) < 2 then
						finalResult = funModeWinItem
						item = items[finalResult]
					else
						item = items[finalResult]
					end
					if RNG4:random(1,20) < 2 then
						finalResult = 9
						item = items[finalResult]
					end
				elseif spinTimer > 1000+rO and spinTimer <= 1070-rO and SliderNum == 4 then
					if RNG4:random(1,1+(Slider[1].itemCount[funModeWinItem]+Slider[2].itemCount[funModeWinItem]+Slider[3].itemCount[funModeWinItem])*4) < 2 then
						finalResult = funModeWinItem
						item = items[finalResult]
					else
						item = items[finalResult]
					end
					if RNG4:random(1,35) < 2 and multiplayMod > 0 then
						finalResult = 9
						item = items[finalResult]
					end
				else
					item = items[finalResult]
				end
			else
				if spinTimer > 550 and spinTimer <= 725 and SliderNum == 1 then
					if RNG4:random(1,1+(Slider[1].itemCount[funModeWinItem])/6) < 2 then
						finalResult = funModeWinItem
						item = items[finalResult]
					else
						item = items[finalResult]
					end
					if RNG4:random(1,20) < 2 and multiplayMod > 0 then
						finalResult = 9
						item = items[finalResult]
					end
				elseif spinTimer > 725 and spinTimer <= 850 and SliderNum == 2 then
					if RNG4:random(1,1+(Slider[1].itemCount[funModeWinItem]+Slider[2].itemCount[funModeWinItem])/5) < 2 then
						finalResult = funModeWinItem
						item = items[finalResult]
					else
						item = items[finalResult]
					end
					if RNG4:random(1,30) < 2 and multiplayMod > 0 then
						finalResult = 9
						item = items[finalResult]
					end
				elseif spinTimer > 850 and spinTimer <= 950 and SliderNum == 3 then
					if RNG4:random(1,1+(Slider[1].itemCount[funModeWinItem]+Slider[2].itemCount[funModeWinItem]+Slider[3].itemCount[funModeWinItem])/3) < 2 then
						finalResult = funModeWinItem
						item = items[finalResult]
					else
						item = items[finalResult]
					end
					if RNG4:random(1,40) < 2 and multiplayMod > 0 then
						finalResult = 9
						item = items[finalResult]
					end
				elseif spinTimer > 950 and spinTimer <= 1100 and SliderNum == 4 then
					if RNG4:random(1,1+(Slider[1].itemCount[funModeWinItem]+Slider[2].itemCount[funModeWinItem]+Slider[3].itemCount[funModeWinItem]+Slider[4].itemCount[funModeWinItem])*3) < 2 then
						finalResult = funModeWinItem
						item = items[finalResult]
					else
						item = items[finalResult]
					end
					if RNG4:random(1,45) < 2 and multiplayMod > 0 then
						finalResult = 9
						item = items[finalResult]
					end
				else
					item = items[finalResult]
				end
			end
		else
			item = items[finalResult]
		end

		
	end

	if spinTimer > Slider[SliderNum].spinTime-GameSpeed*5 then
	if finalResult == 1 or finalResult == 9 then
			Slider[SliderNum].itemCount[1] = Slider[SliderNum].itemCount[1] + 1
		end
	
		if finalResult == 2 or finalResult == 9  then
			Slider[SliderNum].itemCount[2] = Slider[SliderNum].itemCount[2] + 1
		end
	
		if finalResult == 3 or finalResult == 9  then
			Slider[SliderNum].itemCount[3] = Slider[SliderNum].itemCount[3] + 1
		end
	
		if finalResult == 4 or finalResult == 9  then
			Slider[SliderNum].itemCount[4] = Slider[SliderNum].itemCount[4] + 1
		end
	
		if finalResult == 5 or finalResult == 9  then
			Slider[SliderNum].itemCount[5] = Slider[SliderNum].itemCount[5] + 1
		end
	
		if finalResult == 6 or finalResult == 9  then
			Slider[SliderNum].itemCount[6] = Slider[SliderNum].itemCount[6] + 1
		end
	
		if finalResult == 7 or finalResult == 9  then
			Slider[SliderNum].itemCount[7] = Slider[SliderNum].itemCount[7] + 1
		end
		if finalResult == 8 or finalResult == 9  then
			Slider[SliderNum].itemCount[8] = Slider[SliderNum].itemCount[8] + 1
		end
	end

	--finalResult = math.round(RNG5:random(2000,8000)/1000,0) --(DEBUG)
	--print(finalResult)
	if winSevensSPIN == 1 then
		local sItem = 8
		if SliderNum == 1 then
			if spinTimer > 120 + GameSpeed*5 and spinTimer < 200 - GameSpeed*5 then
				finalResult = sItem --(DEBUG)
			end
		end
		if SliderNum == 2 then
			if spinTimer > 230 + GameSpeed*5 and spinTimer < 370 - GameSpeed*5 then
				finalResult = sItem --(DEBUG)
			end
		end
		if SliderNum == 3 then
			if spinTimer > 380 + GameSpeed*5 and spinTimer < 455 - GameSpeed*5 then
				finalResult = sItem --(DEBUG)
			end
		end
		if SliderNum == 4 then
			if spinTimer > 500 + GameSpeed*5 and spinTimer < 600 - GameSpeed*5 then
				finalResult = sItem --(DEBUG)
			end
		end
	end
	--DEBUG
		--finalResult = RNG2:random(1,8)
	--DEBUG

	item = items[finalResult]
	return item
end


local toggleCheckWin = 1

local winTimer = 1
local winTimerStop = 0
local winLineID = 1
local changedWinTimer = 1

local winFrameID = 1
local multFrameID = 1
local multFrameTimer = 0

local showWin = 0
local skipWin = 0
local skipWin2 = 0

local transferWin = 0
local counterTimer = 0
local changedCounter = 0

local ALPHA_MULTI = 1
local ALPHA_TRANS = 0


function love.keypressed(key)
	if SPIN == 0 then
		if key == "kp8" then
			CREDITS = CREDITS + 1000
		end
		if key == "kp7" then
			CREDITS = CREDITS + 100
		end
		if key == "kp+" and SPIN == 0 and showWin == 0 then
			love.audio.stop(sounds[10])
			love.audio.play(sounds[10])
			if BET >= 10 then
				if BET >= 60 then
					if BET >= 100 then
						if BET >= 500 then
							BET = BET + 500
						else
							BET = BET + 100
						end
					else
						BET = BET + 20
					end
				else
					BET = BET + 10
				end
			else
			     BET = BET + 5
			end 
		end
		if key == "kp-" and SPIN == 0 and showWin == 0  then
			love.audio.stop(sounds[10])
			love.audio.play(sounds[10])
			if BET >= 20 then
				if BET >= 80 then
					if BET >= 200 then
						if BET >= 1000 then
							BET = BET - 500
						else
							BET = BET - 100
						end
					else
						BET = BET - 20
					end
				else
					BET = BET - 10
				end
			else
				if BET >= 10 then
			     	BET = BET - 5
			     end
			end 
		end
	end
   if key == "space" then
   		if showWin == 0 then
	   		if SPIN == 0 and CREDITS >= BET then
	   			setWinRate(winRateDynamic, 1, multiRate)
	   			winRateDynamic = math.clamp(winRateDynamic+winRate/10,0,winRate)

	   			if funMode == 1 then
	   				if RNG2:random(1,funModeWinChance) == 1 then

	   					funModeSpin = 1
	   					if RNG2:random(1,funModeSpecialWinChance) == 2 then
	   						funModeWinItem = math.round(RNG2:random(6,8))
	   					else
	   						funModeWinItem = math.round(RNG2:random(1,5))
	   					end

	   				else
	   					funModeSpin = 0
	   					funModeWinItem = 0
	   				end
	   			else
	   				funModeSpin = 0
	   				funModeWinItem = 0
	   			end

	   			print("WINITEM: "..funModeWinItem)


	   			love.audio.play(sounds[1])
	   			SPIN = 1

	   			Slider[1].speed = GameSpeed
	   			Slider[2].speed = GameSpeed
	   			Slider[3].speed = GameSpeed
	   			Slider[4].speed = GameSpeed

	   			for i = 1,5 do
					local ITEM = {}
					Slider[1][i].y = yOffset+GameSizeY*(i-1)

				end
			
				for i = 1,5 do
					local ITEM = {}
					Slider[2][i].y = yOffset+GameSizeY*(i-1)
			
				end
			
				for i = 1,5 do
					local ITEM = {}
					Slider[3][i].y = yOffset+GameSizeY*(i-1)
				end

				for i = 1,5 do
					local ITEM = {}
					Slider[4][i].y = yOffset+GameSizeY*(i-1)
				end

				GameSpeed = -1

	   			--GameSpeed = RNG:random(1500,1800)/1000

	   			CREDITS = CREDITS - BET
	   			if CREDITS < BET then
	   				--CREDITS = 2000
	   			end


	   			transformTimer = 1

	   			toggleCheckWin = 1
	   			winTimer = 1
	   			changedWinTimer = 1
	   			winLineID = 1
	   			winFrameID = 1
	   			skipWin = 0
	   			skipWin2 = 0
	   			multFrameID = 1
	   			multFrameTimer = 0

	   			Slider[1].multiplaySymbol = 0
	   			Slider[2].multiplaySymbol = 0
	   			Slider[3].multiplaySymbol = 0
	   			Slider[4].multiplaySymbol = 0

				local winRandomizer = RNG:random(1,100)
				local melonBonus = RNG:random(1,650)

				if melonBonus < 10 then
					melonChanceMod = 1
				else
					melonChanceMod = 1000
				end

				if winRandomizer <= bonusWinChance then
					winChanceModifier = math.round(1000/winRandomizer)
				else
					winChanceModifier = winChanceModifier_base
				end

				multiplayMod = multiplayMod_base


	   			Slider[1].itemCount[1] = 0
				Slider[1].itemCount[2] = 0
				Slider[1].itemCount[3] = 0
				Slider[1].itemCount[4] = 0
				Slider[1].itemCount[5] = 0
				Slider[1].itemCount[6] = 0
				Slider[1].itemCount[7] = 0

				Slider[2].itemCount[1] = 0
				Slider[2].itemCount[2] = 0
				Slider[2].itemCount[3] = 0
				Slider[2].itemCount[4] = 0
				Slider[2].itemCount[5] = 0
				Slider[2].itemCount[6] = 0
				Slider[2].itemCount[7] = 0

				Slider[3].itemCount[1] = 0
				Slider[3].itemCount[2] = 0
				Slider[3].itemCount[3] = 0
				Slider[3].itemCount[4] = 0
				Slider[3].itemCount[5] = 0
				Slider[3].itemCount[6] = 0
				Slider[3].itemCount[7] = 0

				Slider[4].itemCount[1] = 0
				Slider[4].itemCount[2] = 0
				Slider[4].itemCount[3] = 0
				Slider[4].itemCount[4] = 0
				Slider[4].itemCount[5] = 0
				Slider[4].itemCount[6] = 0
				Slider[4].itemCount[7] = 0

				STOP = 0
	      		winTimerStop = 0
	      		LINES = {}
	      		lineID = 0
	      		counterTimer = 0
	      		changedCounter = 0
	    		itemCount_1 = 0
				itemCount_2 = 0
				itemCount_3 = 0
				itemCount_4 = 0
				itemCount_5 = 0
				itemCount_6 = 0
				itemCount_7 = 0
				itemCount_8 = 0

	   		end
   		else
   			skipWin = 1
   		end
	end

end

function love.load()
	setWinRate(winRate, 1, multiRate)
	AnimatedLogo = newAnimation(LogoAnim, 1056/3, 796/4, 1)

	for i = 1,5 do
		local ITEM = {}
		ITEM.x = Slider[1].x
		ITEM.y = Slider[1].y + GameSizeY*(i-1)
		ITEM.item = getRandom(1)

		table.insert(Slider[1], ITEM)
	end

	for i = 1,5 do
		local ITEM = {}
		ITEM.x = Slider[2].x
		ITEM.y = Slider[2].y + GameSizeY*(i-1)
		ITEM.item = getRandom(2)

		table.insert(Slider[2], ITEM)
	end

	for i = 1,5 do
		local ITEM = {}
		ITEM.x = Slider[3].x
		ITEM.y = Slider[3].y + GameSizeY*(i-1)
		ITEM.item = getRandom(3)

		table.insert(Slider[3], ITEM)
	end

	for i = 1,5 do
		local ITEM = {}
		ITEM.x = Slider[4].x
		ITEM.y = Slider[4].y + GameSizeY*(i-1)
		ITEM.item = getRandom(4)

		table.insert(Slider[4], ITEM)
	end
	
end

local lastWin = 0
function love.update(dt)
	AnimatedLogo.currentTime = AnimatedLogo.currentTime + dt
    if AnimatedLogo.currentTime >= AnimatedLogo.duration then
        AnimatedLogo.currentTime = AnimatedLogo.currentTime - AnimatedLogo.duration
    end

	if love.keyboard.isDown("kp,") then
		winChanceModifier = winChanceModifier_base
	else
		winChanceModifier = winChanceModifier_base
	end

	curTime = curTime + 1*dt 

	if STOP == 1 then
		


		SPIN = 0
		Slider[1].stop = 0
		Slider[2].stop = 0
		Slider[3].stop = 0
		Slider[4].stop = 0

		spinTimer = 0

		multiplayMod = multiplayMod_base

		Slider[1].multiplaySymbol = 0
		Slider[2].multiplaySymbol = 0
		Slider[3].multiplaySymbol = 0
		Slider[4].multiplaySymbol = 0


		if #winLines > 0 then
		

			if skipWin == 1 then
				if payLines[winLineID][2] > 1 then
					transformTimer = math.clamp(transformTimer + 5,0,255)
					--print("timer "..transformTimer)
					if transformTimer >= 255 then
						winTimer = winTimer + 0.1
					end
				else
					winTimer = winTimer + 0.1
				end
			end
			if skipWin2 == 0 and skipWin == 0 then
				if payLines[winLineID][2] > 1 then
					if transformTimer == 1 then
						love.audio.stop(sounds[18])
						love.audio.play(sounds[18])
					end
					transformTimer = math.clamp(transformTimer + 1,0,255)
					--print("timer "..transformTimer)
					if transformTimer >= 255 then
						winTimer = winTimer + 0.008
					end
				else
					winTimer = winTimer + 0.008
				end
				multFrameTimer = multFrameTimer + 0.2
			end
			if math.round(winTimer) > changedWinTimer then

				changedWinTimer = math.round(winTimer)

				if math.round(winTimer) <= #winLines[winLineID]+1 then
					love.audio.play(sounds[2])
				elseif math.round(winTimer) == #winLines[winLineID]+2 then
					if skipWin == 1 then
						WIN = WIN + (BET*payLines[winLineID][1])*payLines[winLineID][2]
						lastWin = WIN
						if winLineID == #winLines then
							love.audio.play(sounds[4])
						end
					elseif skipWin2 == 1 then
						WIN = WIN + (BET*payLines[winLineID][1])*payLines[winLineID][2]
						lastWin = WIN
						if winLineID == #winLines then
							love.audio.play(sounds[4])
						end
					else
						WIN = WIN + (BET*payLines[winLineID][1])*payLines[winLineID][2]
						lastWin = WIN
							
							if payLines[winLineID][2] == 2 and payLines[winLineID][1] ~= 160 then
								love.audio.play(sounds[3])
							elseif payLines[winLineID][2] == 4 and payLines[winLineID][1] ~= 160 then
								love.audio.play(sounds[5])
							elseif payLines[winLineID][2] == 8 and payLines[winLineID][1] ~= 160 then
								love.audio.play(sounds[6])
							else
								if #winLines[winLineID] > 3 then
									if payLines[winLineID][1] == 160 then
										love.audio.stop(sounds[9])
										love.audio.play(sounds[9])
										if payLines[winLineID][2] == 2 then
											love.audio.play(sounds[3])
										elseif payLines[winLineID][2] == 4 then
											love.audio.play(sounds[5])
										elseif payLines[winLineID][2] == 8 then
											love.audio.play(sounds[6])
										end
									elseif payLines[winLineID][1] == 60 then
										love.audio.stop(sounds[13])
										love.audio.play(sounds[13])
									elseif payLines[winLineID][1] == 40 then
										love.audio.stop(sounds[13])
										love.audio.play(sounds[13])
									elseif payLines[winLineID][1] == 4 then
										love.audio.stop(sounds[8])
										love.audio.play(sounds[8])
									else
										love.audio.play(sounds[8])
									end
								else
									if payLines[winLineID][1] == 4 then
										love.audio.stop(sounds[12])
										love.audio.play(sounds[12])
									elseif payLines[winLineID][1] == 6 then
										love.audio.stop(sounds[15])
										love.audio.play(sounds[15])
									elseif payLines[winLineID][1] == 16 then
										love.audio.stop(sounds[9])
										love.audio.play(sounds[9])
									else
										love.audio.play(sounds[7])
									end
								end
							end
					end
				end
			end
			if math.round(winTimer) > #winLines[winLineID] then
				multFrameID = multFrameID + 0.03
				if multFrameID > 5 then
					multFrameID = 1
				end
			end
			if math.round(winTimer) > #winLines[winLineID]+2 then
				if winFrameID < 2 then
					winFrameID = winFrameID + 0.005
				else
					winFrameID = 1
				end
			end
			if math.round(winTimer) > 2 then
				
			end

			if math.round(winTimer) > #winLines[winLineID]+10 then
				if #winLines > winLineID then
					winLineID = winLineID+1
					winTimer = 1
					changedWinTimer = 1
					transformTimer = 1

				else
					--showWin = 0
					if WIN > 0 and transferWin == 0 then
						transferWin = 1
						counterTimer = 0
					end
				end
			end
		end

		if transferWin == 1 then
				
			counterTimer = counterTimer + 0.5
			if math.round(counterTimer) > changedCounter+10 then
				changedCounter = counterTimer

				CREDITS = CREDITS + math.round(WIN/10)
				WIN = WIN - math.round(WIN/10)
				love.audio.play(sounds[16])

				if WIN == 4 then
					CREDITS = CREDITS + 4
					showWin = 0
					transferWin = 0
					WIN = 0
					if funMode then
						
					else
						winRateDynamic = math.clamp(winRateDynamic - math.clamp(BET/3,2,999999),0,100000000)
					end
				end

			end
		end
	end

	if SPIN == 1 and STOP == 0 then
		spinTimer=spinTimer+1
		GameSpeed = math.clamp(GameSpeed + 0.03,-1000,6)
		
		if Slider[1].stop ~= 1 then 
		for k,v in ipairs(Slider[1]) do

			Slider[1].lastID = 5

			if spinTimer <= Slider[1].spinTime then

				Slider[1].speed = GameSpeed
				v.y = v.y + Slider[1].speed

			elseif spinTimer >= Slider[1].spinTime then
				if Slider[1][Slider[1].lastID].y > 645-GameSpeed then
					Slider[1].stop = 1
					love.audio.stop(sounds[11])
					love.audio.play(sounds[11])
					linesInsertSlider(1)

				else
					v.y = v.y + Slider[1].speed
				end
			end

			if v.y > 645 then
				v.y = v.y - GameSizeY*5
				v.item = getRandom(1)
			end
		end
		else
			for k,v in ipairs(Slider[1]) do
				if Slider[1][Slider[1].lastID].y >= 645-GameSpeed then
					Slider[1].speed = math.clamp(Slider[1].speed-0.05,-1,20)
					v.y = v.y + Slider[1].speed
				end
			end
		end

		if Slider[2].stop ~= 1 then 
		for k,v in ipairs(Slider[2]) do
			Slider[2].speed = GameSpeed
			Slider[2].lastID = 5
			if spinTimer <= Slider[2].spinTime then

				v.y = v.y + GameSpeed
			elseif spinTimer >= Slider[2].spinTime then
				if Slider[2][Slider[2].lastID].y > 645-GameSpeed then
				Slider[2].stop = 1
				love.audio.stop(sounds[11])
				love.audio.play(sounds[11])
				linesInsertSlider(2)

				else
					v.y = v.y + GameSpeed
				end
			end

			if v.y > 645 then
				v.y = v.y - GameSizeY*5
				v.item = getRandom(2)
			end
		end
		else
			for k,v in ipairs(Slider[2]) do
				if Slider[2][Slider[2].lastID].y >= 645-GameSpeed then
					Slider[2].speed = math.clamp(Slider[2].speed-0.05,-1,20)
					v.y = v.y + Slider[2].speed
				end
			end
		end

		if Slider[3].stop ~= 1 then 
		for k,v in ipairs(Slider[3]) do
			Slider[3].speed = GameSpeed
			Slider[3].lastID = 5
			if spinTimer <= Slider[3].spinTime then

				v.y = v.y + GameSpeed
			elseif spinTimer >= Slider[3].spinTime then
				if Slider[3][Slider[3].lastID].y > 645-GameSpeed then
					Slider[3].stop = 1
					love.audio.stop(sounds[11])
					love.audio.play(sounds[11])
					linesInsertSlider(3)

				else
					v.y = v.y + GameSpeed
				end
			end

			if v.y > 645 then
				v.y = v.y - GameSizeY*5
				v.item = getRandom(3)
			end
		end
		else
			for k,v in ipairs(Slider[3]) do
				if Slider[3][Slider[3].lastID].y >= 645-GameSpeed then
					Slider[3].speed = math.clamp(Slider[3].speed-0.05,-1,20)
					v.y = v.y + Slider[3].speed
				end
			end
		end

		if Slider[4].stop ~= 1 then 
		for k,v in ipairs(Slider[4]) do
			Slider[4].speed = GameSpeed
			Slider[4].lastID = 5
			if spinTimer <= Slider[4].spinTime then

				v.y = v.y + GameSpeed
			elseif spinTimer >= Slider[4].spinTime then
				if Slider[4][Slider[4].lastID].y > 645-GameSpeed then
					Slider[4].stop = 1
					love.audio.stop(sounds[11])
					love.audio.play(sounds[11])
					linesInsertSlider(4)

				--/GAME END
			else
				v.y = v.y + GameSpeed
			end
			end

			if v.y > 645 then
				v.y = v.y - GameSizeY*5
				v.item = getRandom(4)
			end
		end
		else
			for k,v in ipairs(Slider[4]) do
				if Slider[4][Slider[4].lastID].y >= 645-GameSpeed then
					Slider[4].speed = math.clamp(Slider[4].speed-0.05,-1,20)
					v.y = v.y + Slider[4].speed
				else
					if toggleCheckWin == 1 then
						checkWin2()
						checkPay()

						STOP = 1
						toggleCheckWin = 0

						if #winLines > 0 then
							showWin = 1
						end
					end
				end
			end
		end

	else
	end

	if showWin == 0 then
		winLines = {}
	end

end



local function drawSlider1()
   for k,v in ipairs(Slider[1]) do

   		if k == Slider[1].lastID then
   			love.graphics.setColor(0,1,0,1)
   		else
   			love.graphics.setColor(1,1,1,1)
   		end
      	--love.graphics.rectangle("fill", v.x, v.y, GameSizeX, GameSizeY-2)
      	love.graphics.setColor(1,1,1,1)

      	if #winLines > 0 then
      		if v == winLines[winLineID][1] then
      			if v.item[1] == items[9][1] and transferWin == 0 then
      				if payLines[winLineID][2] > 1 then
      					love.graphics.setColor(1,1,1,transformTimer/255)
      					love.graphics.draw(payLines[winLineID][3],v.x+GameSizeX/2,v.y+GameSizeY/2,0,0.75,0.75,payLines[winLineID][3]:getWidth()/2,payLines[winLineID][3]:getHeight()/2)
      					love.graphics.setColor(1,1,1,1-transformTimer/255)
      					love.graphics.draw(v.item[1],v.x+GameSizeX/2,v.y+GameSizeY/2,0,0.75,0.75,v.item[1]:getWidth()/2,v.item[1]:getHeight()/2)
      				else
      					love.graphics.setColor(1,1,1,1)
      				end
      			else
      				love.graphics.draw(v.item[1],v.x+GameSizeX/2,v.y+GameSizeY/2,0,0.75,0.75,v.item[1]:getWidth()/2,v.item[1]:getHeight()/2)
      			end
      		elseif showWin == 1 and transferWin == 0 then
      			love.graphics.setColor(1,1,1,0.35)
      			love.graphics.draw(v.item[1],v.x+GameSizeX/2,v.y+GameSizeY/2,0,0.75,0.75,v.item[1]:getWidth()/2,v.item[1]:getHeight()/2)
      		else
      			love.graphics.setColor(1,1,1,1)
      			love.graphics.draw(v.item[1],v.x+GameSizeX/2,v.y+GameSizeY/2,0,0.75,0.75,v.item[1]:getWidth()/2,v.item[1]:getHeight()/2)
      		end
 		else
 			love.graphics.setColor(1,1,1,1)
      		if v.item[1] ~= items[9][1] then
      			love.graphics.draw(v.item[1],v.x+GameSizeX/2,v.y+GameSizeY/2,0,0.75,0.75,v.item[1]:getWidth()/2,v.item[1]:getHeight()/2)
      		else
      			love.graphics.draw(v.item[1],v.x+GameSizeX/2,v.y+GameSizeY/2,0,0.75,0.75,v.item[1]:getWidth()/2,v.item[1]:getHeight()/2)
      		end
      	end
   end
end
local function drawSlider2()
   for k,v in ipairs(Slider[2]) do
   		if k == Slider[2].lastID then
   			love.graphics.setColor(0,1,0,1)
   		else
   			love.graphics.setColor(1,1,1,1)
   		end
      	--love.graphics.rectangle("fill", v.x, v.y, GameSizeX, GameSizeY-2)
      	love.graphics.setColor(1,1,1,1)

      	if #winLines > 0 then
      		if v == winLines[winLineID][2] then
      			if v.item[1] == items[9][1] and transferWin == 0 then
      				if payLines[winLineID][2] > 1 then
      					love.graphics.setColor(1,1,1,transformTimer/255)
      					love.graphics.draw(payLines[winLineID][3],v.x+GameSizeX/2,v.y+GameSizeY/2,0,0.75,0.75,payLines[winLineID][3]:getWidth()/2,payLines[winLineID][3]:getHeight()/2)
      					love.graphics.setColor(1,1,1,1-transformTimer/255)
      					love.graphics.draw(v.item[1],v.x+GameSizeX/2,v.y+GameSizeY/2,0,0.75,0.75,v.item[1]:getWidth()/2,v.item[1]:getHeight()/2)
      				else
      					love.graphics.setColor(1,1,1,1)
      				end
      			else
      				love.graphics.draw(v.item[1],v.x+GameSizeX/2,v.y+GameSizeY/2,0,0.75,0.75,v.item[1]:getWidth()/2,v.item[1]:getHeight()/2)
      			end
      		elseif showWin == 1 and transferWin == 0  then
      			love.graphics.setColor(1,1,1,0.35)
      			love.graphics.draw(v.item[1],v.x+GameSizeX/2,v.y+GameSizeY/2,0,0.75,0.75,v.item[1]:getWidth()/2,v.item[1]:getHeight()/2)
      		else
      			love.graphics.setColor(1,1,1,1)
      			love.graphics.draw(v.item[1],v.x+GameSizeX/2,v.y+GameSizeY/2,0,0.75,0.75,v.item[1]:getWidth()/2,v.item[1]:getHeight()/2)
      		end
 		else
      		if v.item[1] ~= items[9][1] then
      			love.graphics.draw(v.item[1],v.x+GameSizeX/2,v.y+GameSizeY/2,0,0.75,0.75,v.item[1]:getWidth()/2,v.item[1]:getHeight()/2)
      		else
      			love.graphics.draw(v.item[1],v.x+GameSizeX/2,v.y+GameSizeY/2,0,0.75,0.75,v.item[1]:getWidth()/2,v.item[1]:getHeight()/2)
      		end
      	end
   end
end

local function drawSlider3()
   for k,v in ipairs(Slider[3]) do
   		if k == Slider[3].lastID then
   			love.graphics.setColor(0,1,0,1)
   		else
   			love.graphics.setColor(1,1,1,1)
   		end
      	--love.graphics.rectangle("fill", v.x, v.y, GameSizeX, GameSizeY-2)
      	love.graphics.setColor(1,1,1,1)

   		if #winLines > 0 then
      		if v == winLines[winLineID][3] then
      			if v.item[1] == items[9][1] and transferWin == 0 then
      				if payLines[winLineID][2] > 1 then
      					love.graphics.setColor(1,1,1,transformTimer/255)
      					love.graphics.draw(payLines[winLineID][3],v.x+GameSizeX/2,v.y+GameSizeY/2,0,0.75,0.75,payLines[winLineID][3]:getWidth()/2,payLines[winLineID][3]:getHeight()/2)
      					love.graphics.setColor(1,1,1,1-transformTimer/255)
      					love.graphics.draw(v.item[1],v.x+GameSizeX/2,v.y+GameSizeY/2,0,0.75,0.75,v.item[1]:getWidth()/2,v.item[1]:getHeight()/2)
      				else
      					love.graphics.setColor(1,1,1,1)
      				end
      			else
      				love.graphics.draw(v.item[1],v.x+GameSizeX/2,v.y+GameSizeY/2,0,0.75,0.75,v.item[1]:getWidth()/2,v.item[1]:getHeight()/2)
      			end
      		elseif showWin == 1 and transferWin == 0  then
      			love.graphics.setColor(1,1,1,0.35)
      			love.graphics.draw(v.item[1],v.x+GameSizeX/2,v.y+GameSizeY/2,0,0.75,0.75,v.item[1]:getWidth()/2,v.item[1]:getHeight()/2)
      		else
      			love.graphics.setColor(1,1,1,1)
      			love.graphics.draw(v.item[1],v.x+GameSizeX/2,v.y+GameSizeY/2,0,0.75,0.75,v.item[1]:getWidth()/2,v.item[1]:getHeight()/2)
      		end
 		else
      		if v.item[1] ~= items[9][1] then
      			love.graphics.draw(v.item[1],v.x+GameSizeX/2,v.y+GameSizeY/2,0,0.75,0.75,v.item[1]:getWidth()/2,v.item[1]:getHeight()/2)
      		else
      			love.graphics.draw(v.item[1],v.x+GameSizeX/2,v.y+GameSizeY/2,0,0.75,0.75,v.item[1]:getWidth()/2,v.item[1]:getHeight()/2)
      		end
      	end
   end
end
local function drawSlider4()
   for k,v in ipairs(Slider[4]) do
   		if k == Slider[4].lastID then
   			love.graphics.setColor(0,1,0,1)
   		else
   			love.graphics.setColor(1,1,1,1)
   		end
      	--love.graphics.rectangle("fill", v.x, v.y, GameSizeX, GameSizeY-2)
      	love.graphics.setColor(1,1,1,1)

      	if #winLines > 0 then
      		if v == winLines[winLineID][4] then
      			if v.item[1] == items[9][1] and transferWin == 0 then
      				if payLines[winLineID][2] > 1 then
      					love.graphics.setColor(1,1,1,transformTimer/255)
      					love.graphics.draw(payLines[winLineID][3],v.x+GameSizeX/2,v.y+GameSizeY/2,0,0.75,0.75,payLines[winLineID][3]:getWidth()/2,payLines[winLineID][3]:getHeight()/2)
      					love.graphics.setColor(1,1,1,1-transformTimer/255)
      					love.graphics.draw(v.item[1],v.x+GameSizeX/2,v.y+GameSizeY/2,0,0.75,0.75,v.item[1]:getWidth()/2,v.item[1]:getHeight()/2)
      				else
      					love.graphics.setColor(1,1,1,1)
      				end
      			else
      				love.graphics.draw(v.item[1],v.x+GameSizeX/2,v.y+GameSizeY/2,0,0.75,0.75,v.item[1]:getWidth()/2,v.item[1]:getHeight()/2)
      			end
      		elseif showWin == 1 and transferWin == 0  then
      			love.graphics.setColor(1,1,1,0.35)
      			love.graphics.draw(v.item[1],v.x+GameSizeX/2,v.y+GameSizeY/2,0,0.75,0.75,v.item[1]:getWidth()/2,v.item[1]:getHeight()/2)
      		else
      			love.graphics.setColor(1,1,1,1)
      			love.graphics.draw(v.item[1],v.x+GameSizeX/2,v.y+GameSizeY/2,0,0.75,0.75,v.item[1]:getWidth()/2,v.item[1]:getHeight()/2)
      		end
 		else
      		if v.item[1] ~= items[9][1] then
      			love.graphics.draw(v.item[1],v.x+GameSizeX/2,v.y+GameSizeY/2,0,0.75,0.75,v.item[1]:getWidth()/2,v.item[1]:getHeight()/2)
      		else
      			love.graphics.draw(v.item[1],v.x+GameSizeX/2,v.y+GameSizeY/2,0,0.75,0.75,v.item[1]:getWidth()/2,v.item[1]:getHeight()/2)
      		end
      	end
   end
end

local FONT = love.graphics.newFont("font3.ttf",55)
local FONT2 = love.graphics.newFont("font.ttf",15)


function love.draw()
	love.graphics.setFont(FONT)


	love.graphics.setColor(1,1,1,1)
	--postEffect5:draw(function()
		drawSlider1()
		drawSlider2()
		drawSlider3()
		drawSlider4()
	--end)

	love.graphics.setColor(1,1,1,1)
	love.graphics.draw(GFXoverlay,0,0,0,0.75,0.75)


	love.graphics.setColor(0,1,0,1)

	love.graphics.setColor(1,1,1,1)


	love.graphics.setColor(1,1,1,1)
	if STOP == 1 then
		if showWin == 1 and transferWin == 0 then
		for k,v in ipairs(winLines) do
			if k == winLineID then
				for o,p in ipairs(v) do
					if o < math.round(winTimer) then
						love.graphics.draw(winFrame[math.round(winFrameID)],p.x-18,p.y-5,0,1.27,1.19)
					else
					end
					if math.round(winTimer) >= 5 then
						if payLines[k][2] == 2 then
							love.graphics.draw(multFrame[1][math.round(multFrameID)],p.x+27,p.y+27,0,1.2,1.2)
						elseif payLines[k][2] == 4 then
							love.graphics.draw(multFrame[2][math.round(multFrameID)],p.x+27,p.y+27,0,1.2,1.2)
						elseif payLines[k][2] == 8 then
						    love.graphics.draw(multFrame[3][math.round(multFrameID)],p.x+27,p.y+27,0,1.2,1.2)
						end
					end
				end
			else
			end
		end
		end

	end
	love.graphics.setFont(FONT)
	love.graphics.setColor(0,0,0,0.8)
	love.graphics.rectangle("fill",43,665,1175,42)
	love.graphics.setColor(1,1,1,1)
	love.graphics.print("CREDIT:"..CREDITS,900,670)
	love.graphics.print("BET:"..BET,100,670)
	love.graphics.print("WIN:"..WIN,400,670)
	love.graphics.setFont(FONT2)
	love.graphics.print("lastwin: "..lastWin,400,710)

	if funMode == 1 then
		love.graphics.print("SUPERFUN MODE!",(ScrW/2)+120,30)
	end

	local spriteNum = 1
	if #winLines > 0 and showWin == 1 then
		spriteNum = math.floor(AnimatedLogo.currentTime / AnimatedLogo.duration * #AnimatedLogo.quads) + 1
	else
		spriteNum = 1
	end
    love.graphics.draw(AnimatedLogo.spriteSheet, AnimatedLogo.quads[spriteNum], 488, 0, 0, 0.8)
end